/* dbgpasswd: set a user's password in the DBG password file.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1993, 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: dbgpasswd.c,v 1.2 1996/01/23 12:19:04 tiggr Exp $  */

/* This program probably is very HP-UX specific.  At least, it should be
   installed setuid-root and /bin/passwd should accept `-f password-file'.  */

#include <unistd.h>
#include <stdio.h>
#include <pwd.h>

/* The location of the dbg password file.  Should match the name of the file
   as used by ../tlisp/dbg.tl.  */
#define DB_PASSWD       "/usr/local/etc/dbg.passwd"

int
main (int argc, char **argv)
{
  uid_t r = getuid ();
  struct passwd *pw;

  if (r)
    {
      if (argc != 1)
	{
	  fprintf (stderr, "Usage: %s\n", argv[0]);
	  exit (2);
	}
    }
  else if (argc > 2 || argv[1][0] == '-')
    {
      fprintf (stderr, "usage: %s [user]\n", argv[0]);
      exit (2);
    }
  pw = getpwuid (r);
  if (!pw)
    fprintf (stderr, "You don't exist.  Go away.\n");
  else if (setuid (0))
    perror ("setuid");
  else
    {
      execl ("/bin/passwd", "/bin/passwd", "-f", DB_PASSWD,
	     argc == 2 ? argv[1] : pw->pw_name, NULL);
      perror ("exec (/bin/passwd)");
    }
  return (1);
}
