/* Interface to NSAutoreleasePool class.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: NSAutoreleasePool.h,v 1.3 1996/01/23 12:19:13 tiggr Exp $  */

#import "policy.h"

#if HAVE_REFCOUNTING
#import <foundation/NSAutoreleasePool.h>
#else

#import "TLObject.h"

@interface NSAutoreleasePool: Object
{
  NSAutoreleasePool *parent_pool, *child_pool;
  unsigned int num, cap;
  id *objects;
}

/* Add the object O to the active autorelease pool in the current
   thread.  XXX What?  Multiple threads?  Not until NSThread exists.  */
+(void) addObject: (id) o;

/* Add the object O to the receiver. */
-(void) addObject: (id) o;

#ifdef NSAUTORELEASEPOOL_DECLARE_PRIVATE_METHODS

/* Notify the receiving pool that it has been activated.  Invoked by the
   child to tell the parent it has been released.  */
-(void) activate;

/* Notify the receiving pool that a new pool has been created, which should
   be regarded as its child pool.  */
-(void) setChild: pool;

#endif

@end

#endif
