/* Interface to TLRegex class.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: TLRegex.h,v 1.2 1996/01/23 12:19:22 tiggr Exp $  */

#import "TLObject.h"
#import "TLString.h"
#import "regex.h"

/* The registers used when matching.  */
extern struct re_registers tlstring_patreg;

@interface TLRegex: TLObject
{
  /* Textual representation.  */
  id <TLString> string;

  /* Compiled.  */
  struct re_pattern_buffer pat;
}

+(TLRegex *) regexWithString: (id <TLString>) s;
+(TLRegex *) regexWithString: (id <TLString>) s options: (int) o;

-(const struct re_pattern_buffer *) compiledPattern;

#ifdef TLREGEX_DECLARE_PRIVATE_METHODS

/* Options are the TLString search options.  The only option checked is the
   TLSEARCH_REGEX_FAST.  */
-initWithString: (id <TLString>) s options: (int) o;

#endif

@end
